GET_KEY = $5371
_findsym	.EQU	46CBh
_delvar		.EQU	475Fh
_mm_ldir	.equ	52EDh
_memchk	.EQU	46BBh

_set_mm_num_bytes	.equ	464Fh
;_set_abs_src_addr	.equ	462Fh
_set_abs_dest_addr	.equ	5285h

_ABS_SRC_ADDR	equ	0C392h
_ABS_DEST_ADDR	equ	0C395h
_MM_NUM_BYTES	equ	0C398h

_ldhlind	.EQU	4010h
_cphlde		.EQU	403Ch

BACK:
	ld a,1
	ld (Slide#),a
	ld a,2
	ld (UserPos),a
	call StartGray		;load up the interrupt program & turn on the grayscale
dispSlide:
	call Clear$FC00		;clear the screen
	call Clear$F600		;clear the screen area needed by the grayscale
	call ResumeGray
	call _homeup
	ld hl,SlideText
	call _puts
	ld a,(Slide#)
	ld b,a
	ld hl,(numbering)
	dec hl
	dec hl
findDelay:
	inc hl
	inc hl
	djnz findDelay
	call _ldhlind
	xor a
	call _dispAHL
	ld de,$0002
	ld (_curRow),de
	ld hl,IFtext
	call _puts
	ld de,$0003
	ld (_curRow),de
;	ld hl,DFtext
	call _puts
	ld de,$2505
	ld (_penCol),de
;	ld hl,MAtext
	call _vputs
	ld de,$1000
	ld (_curRow),de
	ld hl,(Slide#)
	xor a
	call _dispAHL
	ld de,$1201
	ld (_curRow),de
	ld hl,Arrows
	set	textInverse,(iy+textflags)
	call _puts
	res textInverse,(iy+textflags)

;the storage we're using in RAM page 1
	call Load_RAM_p1
	ld de,(MEM_START)		;where to put the pic
	ld bc,1024
	call ClearDE
	ld de,(ABS_MEM_START)	;where to put the pic (ABS for getpic)
	ld a,(Slide#)
	ld b,a
	ld a,1
	call GetPic			;copy's the pic to de (on RAM p1)
	ld de,(MEM_START)
	ld hl,1008
	and a
	adc hl,de
	push hl
	ld bc,16
	and a
	adc hl,bc
	ld d,h
	ld e,l
	pop hl
	ldir			;make 2 of the bottom line for the reducing routine

	call Make25%prev	;reduce the pic to 25% & grayscale

KeyLoop:
	call _getky
	cp K_ENTER
	jp z,UserSelected
	cp K_DOWN
	jr z,MoveUserDown
	cp K_UP
	jr z,MoveUserUp
	cp K_LEFT
	jr z,UserChangedL
	cp K_RIGHT
	jp z,UserChangedR
	cp K_EXIT
	jp z,Bye
	call SoftDelay
	call CopyTop2White
	jr KeyLoop

MoveUserDown:
	res textInverse,(iy+textflags)
	call dispUpos					;unhighlight
	ld hl,UserPos
	inc (hl)
	ld a,6
	cp (hl)
	jr nz,MUDok
	ld (hl),1
MUDok:
	set	textInverse,(iy+textflags)
	call dispUpos					;highlight
	res textInverse,(iy+textflags)
	jr KeyLoop

MoveUserUp:
	res textInverse,(iy+textflags)
	call dispUpos					;unhighlight
	ld hl,UserPos
	dec (hl)
	jr nz,MUPok
	ld (hl),5
MUPok:
	set	textInverse,(iy+textflags)
	call dispUpos					;highlight
	res textInverse,(iy+textflags)
	jr KeyLoop

UserChangedL:
	ld a,(UserPos)
	cp 1
	jr nz,notDelay
RepeatChangeL:
	ld a,(Slide#)
	ld b,a
	ld hl,(numbering)
	dec hl
	dec hl
findDelay2:
	inc hl
	inc hl
	djnz findDelay2
	call _ldhlind
	ld de,0
	call _cphlde
	jr z,notDelay
	dec hl
	ld de,$0600
	ld (_curRow),de
	push hl
	xor a
	call _dispAHL
	pop hl
	ld a,(Slide#)
	ld b,a
	ld de,(numbering)
	dec de
	dec de
findDelay3:
	inc de
	inc de
	djnz findDelay3
	ld a,l
	ld (de),a
	inc de
	ld a,h
	ld (de),a
	ld a,%00111111
	out (1),a
	in a,(1)
	bit 5,a	; check if 2nd is being pressed
	call nz,SoftDelayx2
	call CopyTop2White
	ld a,($C001)
	cp 2		;$C001 = 2 when the left Arrow Key is pressed (it's always the key
				;          pressed first if more than one key is pressed)
				;FYI: $C002 = $FF when another key is pressed w/it or another key
	jr z,RepeatChangeL
notDelay:
	ld a,(UserPos)
	cp 2
	jp nz,KeyLoop
	ld hl,Slide#
	dec (hl)
	jp nz,dispSlide
	inc (hl)
	jp KeyLoop


UserChangedR:
	ld a,(UserPos)
	cp 1
	jr nz,notDelayR
RepeatChangeR:
	ld a,(Slide#)
	ld b,a
	ld hl,(numbering)
	dec hl
	dec hl
findDelay4:
	inc hl
	inc hl
	djnz findDelay4
	call _ldhlind
	inc hl
	ld de,0
	call _cphlde
	jr z,notDelayR		;if hl=0, skip this stuff (we can't go higher)
	xor a
	ld de,$0600
	ld (_curRow),de
	push hl
	xor a
	call _dispAHL
	pop hl
	ld a,(Slide#)
	ld b,a
	ld de,(numbering)
	dec de
	dec de
findDelay5:
	inc de
	inc de
	djnz findDelay5
	ld a,l
	ld (de),a
	inc de
	ld a,h
	ld (de),a
	ld a,%00111111
	out (1),a
	in a,(1)
	bit 5,a	; check if 2nd is being pressed
	call nz,SoftDelayx2
	call CopyTop2White
	ld a,($C001)
	cp 3		;$C001 = 3 when the right Arrow Key is pressed (it's always the
				;          key pressed first if more than one key is pressed)
				;FYI: $C002 = $FF when another key is pressed w/it or another key
	jr z,RepeatChangeR
notDelayR:
	ld a,(UserPos)
	cp 2
	jp nz,KeyLoop
	ld hl,Slide#
	ld a,(numSelected)		;aka # of slides
	cp (hl)
	jp z,KeyLoop
	inc (hl)
	jp dispSlide

UserSelected:
	ld a,(UserPos)
	cp 2
	jr nz,USD
	call Clear$FC00
	call EndGray
	call _homeup
	ld hl,GotoText
	call _puts
	ld de,$0F00
	ld (_curRow),de
	ld a,(Slide#)
	ld l,a
	ld h,0
	xor a
	call _dispAHL
USKL:
	call _getky
	cp K_LEFT
	jr z,USL
	cp K_RIGHT
	jr z,USR
	cp K_ENTER
	jp z,dispSlide
	call SoftDelay
	jr USKL
USL:
	ld de,$0F00
	ld (_curRow),de
	ld a,(Slide#)
	dec a
	jr z,USKL
	ld (Slide#),a
	ld l,a
	ld h,0
	xor a
	call _dispAHL
	jr USKL
USR:
	ld de,$0F00
	ld (_curRow),de
	ld a,(numSelected)		;aka # of slides
	ld b,a
	ld a,(Slide#)
	cp b
	jr z,USKL
	inc a
	ld (Slide#),a
	ld l,a
	ld h,0
	xor a
	call _dispAHL
	jr USKL



USD:
	cp 5
	jp nz,USn5
	call Clear$FC00
	call Clear$F600
	call EndGray
	call Load_RAM_p1
	ld hl,(numbering)
	ld (DelayAmt),hl
	ld de,(MEM_START)
	ld a,(numSelected)
	ld (de),a
	inc de
	ld (MEM_loc),de
	ld bc,(FREE_MEM)
	call ClearDE
	ld b,1
	ld a,b
	ld (picnum),a
	ld de,$FC00
	xor a
	call GetPic
	call compressV
	push hl
	call Load_RAM_p1
	pop bc			;bc=len of compressed pic
	ld de,(MEM_loc)
	ld hl,$F600
	ldir			;copy first pic
	ld hl,(DelayAmt)
	ld a,(hl)
	ld (de),a
	inc hl
	inc de
	ld a,(hl)
	ld (de),a
	inc de
	inc hl
	ld (DelayAmt),hl
	ld (MEM_loc),de

CSloop:
;	call Clear$FC00
	ld a,(picnum)
	ld b,a
	ld a,(numSelected)		;number of pics to compress
	cp b
	jp z,doneCS
	inc b
	ld a,b
	ld (picnum),a
	push bc
	ld de,$FC00
	xor a
	call GetPic
	call compressV
	ld (LastCompSize),hl
	pop bc
	dec b
	ld de,$F600
	xor a
	call GetPic
	ld hl,$F600
	ld de,$FC00
	ld bc,1024
CSxorLoop:
	ld a,(de)
	xor (hl)
	ld (de),a
	inc hl
	inc de
	dec bc
	xor a
	cp c
	jr nz,CSxorLoop
	cp b
	jr nz,CSxorLoop
	call compressV
	ld de,(LastCompSize)
	ld a,d
	sub h					;1st size minus the second
	jr c,keepfirst
	jr z,bothequal
keepsecond:
	push hl				;to be poped into bc
;	add hl,de
;	ld de,(MEM_END)

;stuff to put what has been copied already into temp string

	call Load_RAM_p1
	ld de,(MEM_loc)
	ld a,1				;1 means the previous screen is xor'd with the new frame
	ld (de),a
	inc de
	pop bc				;what was hl (len of compressed data)
	ld hl,$F600
	ldir
	ld hl,(DelayAmt)
	ld a,(hl)
	ld (de),a
	inc hl
	inc de
	ld a,(hl)
	ld (de),a
	inc de
	inc hl
	ld (DelayAmt),hl
	ld (MEM_loc),de
	jr CSloop

bothequal:
	ld a,e
	sub l
	jr nc,keepsecond

keepfirst:
;	call Clear$FC00
	ld de,$FC00
	ld a,(picnum)
	ld b,a
	xor a
	call GetPic
	call compressV
	push hl
;	add hl,de
;	ld de,(MEM_END)

;stuff to put what has been copied already into temp string

	call Load_RAM_p1
	ld de,(MEM_loc)
	xor a
	ld (de),a		;0 means screen is overwritten with new frame
	inc de
	pop bc
	ld hl,$F600
	ldir
	ld hl,(DelayAmt)
	ld a,(hl)
	ld (de),a
	inc hl
	inc de
	ld a,(hl)
	ld (de),a
	inc de
	inc hl
	ld (DelayAmt),hl
	ld (MEM_loc),de
	jp CSloop

doneCS:
	ld de,(MEM_START)
	ld hl,(MEM_loc)
	sbc hl,de
	ld (Comp_len),hl
	ld de,DATA_START-AniPrg+3
	add hl,de					;hl now equals the full program length
	ld a,$22
	cp h
	jr nc,hok
	ld a,$23
	cp h
	jp c,Prg2Big
	ld a,$28
	cp l
	jp c,Prg2Big


hok:	
	ex de,hl
	call _memchk
	cp 0
	jr nz,mok
	and a
	sbc hl,de
	ld a,$DC
	cp h
	jp c,NotEnoughMem
	ld a,$DC
	cp h
	jp nz,mok
	ld a,$D8
	cp l
	jp c,NotEnoughMem

mok:
	call _clrScrn
	call _homeup
	ld hl,PrgNameText
	call _puts
	ld a,225
	ld (caps),a
	call _putmap		;disp Alpha cap cur
	xor a
	ld (LenName),a
GetNameLoop:
	ld a,(caps)
	call _putmap
GetNameLoop0:
	HALT
	HALT
	call GET_KEY
	cp 0
	jr z,GetNameLoop0
	ld hl,GetNameLoop
	cp K_DEL
	jr z,GNdel
	cp K_LEFT
	jr z,GNdel
	cp K_ENTER
	jp z,GNdone
	cp K_ALPHA
	ld b,a				;b=key pressed
	jr z,AlphaChange
	ld a,(LenName)
	cp 8
	jr z,GetNameLoop0
	ld a,(caps)
	cp 223
	jr z,GNnum
	ld hl,getkyTable-1
GNtableLoop:
	inc hl
	djnz GNtableLoop
	xor a
	cp (hl)
	jr z,GetNameLoop0
	ld a,(caps)
	cp 225
	jr z,notLower
	ld a,(hl)
	ld b,32
	add a,b
	jr skpNL
notLower:
	ld a,(hl)
skpNL:
	call _putc
	ld hl,LenName
	inc (hl)
	jr GetNameLoop
GNnum:
	ld a,(LenName)
	cp 0
	jp z,GetNameLoop
	ld a,$11
	cp b
	jr nc,GetNameLoop
	ld a,$24
	cp b
	jr c,GetNameLoop
	ld c,$11
	ld a,b
	sub c
	ld b,a
	ld hl,getkyTableNum-1
GNnumLoop:
	inc hl
	djnz GNnumLoop
	ld a,(hl)
	cp 0
	jr z,GetNameLoop
	call _putc
	ld hl,LenName
	inc (hl)
	jr GetNameLoop

GNdel:
	ld hl,LenName
	xor a
	cp (hl)
	jp z,GetNameLoop
	dec (hl)
	ld a,' '
	call _putmap
	ld hl,_curCol
	dec (hl)
	jp GetNameLoop

AlphaChange:
	ld a,(caps)
	cp 225
	jr nz,notCap
	inc a
	ld (caps),a
	jp (hl)
notCap:
	cp 226
	jr nz,notLow
	ld a,223
	ld (caps),a
	jp (hl)
notLow:
	ld a,225
	ld (caps),a
	jp (hl)

GNdone:
	ld a,' '
	call _putmap
	ld a,(LenName)
	cp 0
	jp z,GetNameLoop
	ld hl,_textShadow+21
	ld de,LenName+1
	ld a,(LenName)
	ld b,a
CNameLoop:
	ld a,(hl)
	ld (de),a
	inc hl
	inc de
	djnz CNameLoop


tagain:
	ld hl,AniPrgName
	call _mov10toop1
	call _findsym
	jr c,PrgNotExist
	push hl
	push bc
	push de
	ld hl,_curCol
	ld a,(hl)
	push af
	ld a,5
	ld (_curRow),a
	ld (hl),0
	ld hl,PrgExists
	call _puts
	res appAutoScroll,(iy+appflags)
	set textInverse,(iy+textflags)
	call _puts
	res textInverse,(iy+textflags)
GKloop:
	HALT
	HALT
	call GET_KEY
	cp 0
	jr z,GKloop
	cp K_F1
	jr z,DelPrg
	cp K_F5
	jr nz,GKloop
	ld a,5
	ld (_curRow),a
	xor a
	ld (_curCol),a
	ld b,63
ClearTxtLoop:
	push bc
	ld a,' '
	call _putc
	pop bc
	djnz ClearTxtLoop
	set appAutoScroll,(iy+appflags)

	pop af
	ld (_curCol),a
	ld a,1
	ld (_curRow),a
	pop de
	pop bc
	pop hl
	jp GetNameLoop

DelPrg:
	set appAutoScroll,(iy+appflags)
	pop af
	pop de
	pop bc
	pop hl
	call _delvar











PrgNotExist:
	ld hl,AniPrgName
	call _mov10toop1
	call _ram_page_7	;This will load RAM page #7 in the area between $8000 and $BFFF
						;RAM page 7 contains the VAT (variable allocation table, or something like that)
						;Here are the addresses of all the variables on the calc stored.
						;It's written backwards so the first entry is at $BFFF.

	ld hl,$BFFF		;We want to start searching at the beginning (top/bottom) of the VAT.
	ld d,h			;Copy it to de
	ld e,l			;We could use 'ld de,$BFFF' but it's one byte longer and takes 2 more clock cycles

	ld bc,($D298)	;$D298 contains the address to the end (bottom/top) of the VAT.
	and a			;Clear the carry flag
	sbc hl,bc		;Subtract the bottom from the top to get the length. hl = length of VAT
	ld b,h			;Copy the result to bc
	ld c,l
	ex de,hl		;hl now = start of VAT
	ld ix,LenName	;the var name length and name
	push ix

SearchLoop1:
	pop ix
	ld a,(ix)
SearchLoop2:
	cpdr
	jp po,VarGone
	push ix
	ld a,(LenName)
	inc a				;inc a to accomadate len of name
	ld d,a
CompareLoop1:
	dec d
	xor a				;*********
	cp d
	jr z,Exists
	inc ix
	ld a,(ix)
	cpd
	jp po,VarGone
	jr nz,SearchLoop1
	jr CompareLoop1











Exists:
	ld hl,_curCol
	ld a,(hl)
	push af
	ld a,2
	ld (_curRow),a
	ld (hl),0
	ld hl,VarExists
	call _puts
	pop af
	ld (_curCol),a
	ld a,1
	ld (_curRow),a
	jp GetNameLoop
VarGone:
	ld hl,(Comp_len)
	ld de,DATA_START-AniPrg+3
	add hl,de					;hl now equals the full program length
	call _createprog
	ld a,b
	ld h,d
	ld l,e
	;call _load_ram_ahl
	call _set_abs_dest_addr
	
	ld hl,AniPrg-4
	xor a
	call _set_abs_src_addr

	ld hl,DATA_START-AniPrg+4
	push hl
	ld de,(Comp_len)
	add hl,de
	ld a,l
	ld (AniPrgSize),a
	ld a,h
	ld (AniPrgSize+1),a
	pop hl
	xor a
	call _set_mm_num_bytes

	call _mm_ldir				;copy the program

	ld hl,(MEM_START)
	ld de,$8000
	and a
	sbc hl,de
	ld a,1
	call _set_abs_src_addr

	ld hl,(Comp_len)
	xor a
	inc hl
	call _set_mm_num_bytes

	call _mm_ldir				;copy the data of the program

;	ld a,1
;	ld (Slide#),a
;	ld a,2
;	ld (UserPos),a
;	call ResumeGray
;	jp dispSlide






APpic12:
	call Clear$FC00		;Clear$FC00
	call Load_RAM_p1
	ld hl,(MEM_START)		;DATA_START
	ld b,(hl)							;number of frames
	inc hl
APloop2:
	push bc
	ex de,hl
	call decompV			;decompV
	ex de,hl
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	xor a
	cp b
	jr nz,not02
	cp c
	jr nz,not02
	push hl
	call _getkey
	pop hl
	jr APSkipDelay2
not02:
	call DelayBC2			;delayBC
APSkipDelay2:
	ld a,(hl)
	inc hl
	push hl
	cp 1
	jr z,APcont2
	call Clear$FC00		;Clear$FC00
APcont2:
	pop hl
	pop bc
	djnz APloop2
	jp BACK

DelayBC2:
	halt
	push hl
	call _getky
	pop hl
	cp K_EXIT
	jr z,APExit2
	dec bc
	xor a
	cp b
	jr nz,DelayBC2
	cp c
	jr nz,DelayBC2
	ret

APExit2:
	pop bc			;remove call from stack
	pop bc			;remove bc from stack
	jp BACK







NotEnoughMem:
	ld hl,NEmemText
	jr dispERR
Prg2Big:
	ld hl,P2BText

dispERR
	push hl
	call Clear$FC00
	call _homeup
	pop hl
	call _puts
	call _getkey
	jp BACK



picnum:
	.db 0
MEM_loc:
	.dw 0
LastCompSize:
	.dw 0



USn5:
	jp KeyLoop


Bye:
	call EndGray
	call Clear$FC00
	call Clear$F600
	jp Exit


dispUpos:
	ld a,(UserPos)
	cp 1
	jr nz,notST
	call _homeup
	ld hl,SlideText
	jp _puts			;jp instead of call will make _puts return
						;from this routine for us
notST:
	cp 2
	jr nz,notAR
	ld de,$1201
	ld (_curRow),de
	ld hl,Arrows
	jp _puts
notAR:
	cp 3
	jr nz,notIF
	ld de,$0002
	ld (_curRow),de
	ld hl,IFtext
	jp _puts
notIF:
	cp 4
	jr nz,notDF
	ld de,$0003
	ld (_curRow),de
	ld hl,DFtext
	jp _puts
notDF:				;if not DF it must be MA
	ld de,$2505
	ld (_penCol),de
	ld hl,MAtext
	jp _vputs

CopyTop2White:
	ld hl,$FC00
	ld de,$F600
	ld bc,512
	ldir
	ret

SlideText:
	.db "DELAY:",0
IFtext:
	.db "INSERT FRAME",0
DFtext:
	.db "DELETE FRAME",0
MAtext:
	.db "Make Animation",0
Arrows:
	.db 207," ",5,0
GotoText:
	.db "Jump To Slide #",0
SizeText:
	.db "Compression:         ",0
bytesText:
	.db " from 1024",0
Slide#:
	.dw 0
UserPos:
	.db 0
MemLoc:
	.dw 0
DelayAmt:
	.dw 0
Comp_len:
	.dw 0

AniPrgName
	.db 12
LenName:
	.db 7
	.db "AniPrgA",0

PrgNameText:
	.db "Enter Program Name:  ",0
caps:
	.db 0
VarExists:
	.db "Var Already Exists!",0
PrgExists:
	.db "   Variable Exists!  "
	.db "      OVERWRITE?     ",0
	.db "YES                NO",0
P2BText:
	.db "Compressed Program is"
	.db "too big.  >9000 bytes",0
NEmemText:
	.db "Not Enough Free Mem",0

getkyTable:
	.db 0,0,0,0,0,0,0,0,0,'X','T','O','J','E'
	.db 0,0,0,'W','S','N','I','D',0,0
	.db 'Z','V','R','M','H','C',0,0
	.db 'Y','U','Q','L','G','B',0,0
	.db 0,0,'P','K','F','A'
	.db 0,0,0,0,0,0,0,0,0,0
getkyTableNum:
	.db '3','6','9',0,0,0,0,0
	.db '2','5','8',0,0,0,0
	.db '0','1','4','7'

;************************************
;GetPic
;input:  b=pic to get (1-# of pics)
;        ade=where to put the pic (abs)
;
GetPic:
	di
	ex de,hl
	call _set_abs_dest_addr
	ld a,$3C
	out (0),a		;normal video screen
	ld hl,1008
	xor a
	call _set_mm_num_bytes

	ld hl,DATA-3
findABSADDR:
	inc hl
	inc hl
	inc hl
	djnz findABSADDR
	ld b,(hl)
	inc hl
	ld c,(hl)
	inc hl
	ld a,(hl)
	inc hl
	ld h,b
	ld l,c		;AHL now points to the picture
	call _inc_ptr_ahl	;inc AHL
	call _inc_ptr_ahl	;to skip sign bytes
	call _set_abs_src_addr
	call _mm_ldir

;	ld a,(_ABS_DEST_ADDR+2)
;	ld l,a
;	ld a,(_ABS_DEST_ADDR+1)
;	ld h,a
;	ld a,(_ABS_DEST_ADDR)
;	call _load_ram_ahl
;	ld b,16
;EraseBottomLine:
;	ld (hl),0
;	inc hl
;	djnz EraseBottomLine
;
	ei
	ret






;input- de=location to clear
;       bc=# of bytes to clear
;	de is conserved
ClearDE:
  push de
  ld h,d
  ld l,e
  inc de
  dec bc
  ld (hl),0
  ldir
  pop de
  ret
